PROGRAM LIBGEN(LGO,PASCLIB);

TYPE FILENAME= ARRAY[3..14] OF CHAR;
  BYTE= 0..$FF;

VAR 
  LGO, PASCLIB: FILE OF BYTE;
  RECID, BASE, SIZE, LENGTH: INTEGER;
  DATA: ARRAY[0..2000] OF BYTE;

PROCEDURE OPENFILES;
  TYPE
    EXTENSION = (XBIN,XTXT,XCMD,XBAS,XSYS,XBAK,XSCR,XDAT,
                 XBAC,XDIR,XPRT,XOUT);
  VAR BN, FN: FILENAME;
    I, J:INTEGER;

  PROCEDURE GETNAME(VAR FN: FILENAME; E: EXTENSION);
       EXTERN = 4;

  BEGIN 
    FOR I:=3 TO 14 DO FN[I]:=CHR(0);
    BN:=FN;
    GETNAME(FN,XBIN);
    GETNAME(BN,XDIR);
    IF (FN[4]=CHR(0)) OR (BN[4]=CHR(0)) 
     THEN HALT('REQUIRED FILE NAMES MISSING');
    RESET(LGO,FN);
    REWRITE(PASCLIB,BN)
    END;

  FUNCTION NEXTBYTE: BYTE;
    BEGIN
      NEXTBYTE:=LGO^;
      IF NOT EOF(LGO) THEN GET(LGO)
    END;

  PROCEDURE PROLOGUE;
    BEGIN
      RECID:=NEXTBYTE;
      BASE :=NEXTBYTE*$100+NEXTBYTE;
      LENGTH:=NEXTBYTE
    END;

  PROCEDURE READDATA;
    VAR I:INTEGER;

    BEGIN
      REPEAT
        FOR I:=0 TO LENGTH-1 DO
          DATA[I+BASE]:=NEXTBYTE;
        SIZE:=BASE+LENGTH;
        PROLOGUE
      UNTIL (RECID<>2) OR (BASE=0);
    END;

  PROCEDURE PUTV(B: BYTE);
    BEGIN PASCLIB^:=B; PUT(PASCLIB) END;

  PROCEDURE PUTDATA;
    VAR I,L,N: INTEGER;

    BEGIN PUTV(10);
      FOR I:=0 TO 7 DO PUTV(DATA[I]);
      PUTV(4); PUTV(0);
      FOR I:=0 TO 7 DO PUTV(DATA[I]);
      DATA[7]:=$80;
      N:=7;
      REPEAT
        L:=SIZE-N; IF L>127 THEN L:=127;
        PUTV(1); PUTV(L);
        FOR I:=N TO N+L-1 DO PUTV(DATA[I]);
        N:=N+L;
      UNTIL N=SIZE;
      SIZE:=0
    END;

BEGIN
 OPENFILES;
 PROLOGUE;
 WHILE RECID=2 DO
   BEGIN READDATA; PUTDATA END;
 PUTV(9)
END.
