PROCEDURE BEGINLINE;
BEGIN
  IF EOF THEN WRITELN(' PREMATURE END OF SOURCE FILE');
  LINELENGTH:=0;
  WHILE NOT EOLN AND (LINELENGTH<MAXCHCNT) DO
    BEGIN LINELENGTH:=LINELENGTH+1;
      READ(LINE[LINELENGTH])
    END;
  READLN; CHCNT:=0
END (* BEGINLINE *);

PROCEDURE ENDLINE;
VAR LASTPOS,FREEPOS,CURRPOS,CURRNMR,F,K: INTEGER;
BEGIN
  IF ERRINX>0 THEN   (* OUTPUT ERROR MESSAGES *)
    BEGIN
      FOR K:=1 TO LINELENGTH DO WRITE(LINE[K]);
      WRITELN;
      LASTPOS:=0; FREEPOS:=1;
      FOR K:=1 TO ERRINX DO
        BEGIN
          CURRPOS:=ERRLIST[K].POS; CURRNMR:=ERRLIST[K].NMR;
          IF CURRPOS=LASTPOS THEN WRITE(',')
          ELSE
            BEGIN
              WHILE FREEPOS<CURRPOS DO
                BEGIN WRITE(' '); FREEPOS:=FREEPOS+1 END;
              WRITE('^');
              LASTPOS:=CURRPOS
            END;
          IF CURRNMR<10 THEN F:=1
          ELSE IF CURRNMR<100 THEN F:=2
            ELSE F:=3;
          WRITE(CURRNMR:F);
          FREEPOS:=FREEPOS+F+1
        END;
      WRITELN; ERRINX:=0
    END
END (* ENDLINE *);

PROCEDURE ERROR(FERRNR: INTEGER);
BEGIN
  IF ERRINX>=9 THEN
    BEGIN ERRLIST[10].NMR:=255; ERRINX:=10 END
  ELSE
    BEGIN ERRINX:=ERRINX+1;
      ERRLIST[ERRINX].NMR:=FERRNR
    END;
  ERRLIST[ERRINX].POS:=CHCNT
END (* ERROR *);

FUNCTION STRINGSIZE(LVP: CSP): INTEGER;
VAR N: INTEGER;
BEGIN N:=0;
  REPEAT
    N:=N+LVP^.SLGTH; LVP:=LVP^.SPTR
  UNTIL LVP=NIL;
  STRINGSIZE:=N
END (* STRINGSIZE *);

PROCEDURE INSYMBOL;
(* READ NEXT BASIC SYMBOL OF SOURCE PROGRAM AND RETURN ITS
   DESCRIPTION IN THE GLOBAL VARIABLES SY, OP, ID, VAL AND
   LGTH *)
VAR I,J,K,RADIX: INTEGER;
  LVP,LVP1: CSP; TEST,COMNT: BOOLEAN;
  QUOTECHAR: CHAR;
  HEXSET : SET OF 0..16;
  STRING: PACKED ARRAY [1..STRGLGTH] OF 0..127;
  DIGITS: PACKED ARRAY [0..19] OF 0..15;

  PROCEDURE NEXTCH;
  BEGIN
    IF CHCNT>LINELENGTH THEN
      BEGIN ENDLINE; BEGINLINE END;
    CHCNT:=CHCNT+1;
    IF CHCNT>LINELENGTH THEN CH:=' '
    ELSE CH:=LINE[CHCNT];
    ICH:=ORD(CH)
  END (* NEXTCH *);

  PROCEDURE INCLUDEFILE;
  VAR INNAME:FILENAME;
    I: INTEGER;

  BEGIN (* INCLUDEFILE *)
    FOR I:=3 TO 14 DO INNAME[I]:=CHR(0);
    NEXTCH; INSYMBOL;
    FOR I:=1 TO KK DO INNAME[I+3]:=ID[I];
    IF CH="." THEN BEGIN NEXTCH; INSYMBOL END
      ELSE BEGIN KK:=3; ID:="TXT     " END;
    IF KK<>3 THEN ERROR(999);
    FOR I:=1 TO 3 DO INNAME[I+11]:=ID[I];
    INNAME[3]:=FN[3];
    SETINPUT(INNAME)
  END (* INCLUDEFILE *);

BEGIN (* INSYMBOL *)
  REPEAT COMNT:=TRUE;
    WHILE CH=' ' DO NEXTCH;
    IF (CH>='A') AND (CH<='Z') THEN
      BEGIN KK:=0; ID:='        ';
        REPEAT
          IF KK<ALPHASIZE THEN
            BEGIN KK:=KK+1; ID[KK]:=CH END;
          NEXTCH
        UNTIL NOT (((CH>='0') AND (CH<='9')) OR
                   ((CH>='A') AND (CH<='Z')));
        SY:=IDENT; OP:=NOOP; I:=FRW[KK-1];
        WHILE I<=FRW[KK]-1 DO
          BEGIN
            IF RW[I]=ID THEN
              BEGIN SY:=RSY[I]; OP:=ROP[I] END;
            I:=I+1
          END
      END
    ELSE
      CASE CH OF
 '0','1','2','3','4','5','6','7','8','9': (* DIGIT *)
        BEGIN OP:=NOOP; TEST:=FALSE; RADIX:=10;
          K:=0; SY:=INTCONST; I:=0; J:=ICH-ORD('0');
          HEXSET:=[];
          REPEAT
            IF K<=MXINT10 THEN K:=K*10+J ELSE TEST:=TRUE;
            DIGITS[I]:=J; I:=I+ORD(I<19);
            HEXSET:=HEXSET+[J];
            NEXTCH;
            IF (CH>='0') AND (CH<='9') THEN
              J:=ICH-ORD('0')
            ELSE IF (CH>='A') AND (CH<='F') THEN
              J:=ICH-ORD('A')+10
            ELSE J:=-1
          UNTIL (J<0) ;
          IF CH='(' THEN
            BEGIN NEXTCH; RADIX:=0; TEST:=FALSE;
              WHILE (CH>='0') AND (CH<='9') DO
                BEGIN RADIX:=RADIX*10+ICH-ORD('0');
                  NEXTCH;
                END;
              IF RADIX>16 THEN BEGIN TEST:=TRUE; RADIX:=10 END;
              K:=0;
              FOR I:=0 TO PRED(I) DO
                K:=K*RADIX+DIGITS[I];
              IF CH=')' THEN NEXTCH ELSE TEST:=TRUE
            END;
          IF TEST OR ((HEXSET * [RADIX..16])<>[]) THEN
             ERROR(203);
          VAL.IVAL:=K
        END;
 '"','''': (* STRING *)
        BEGIN LGTH:=0; SY:=STRINGCONST; OP:=NOOP; LVP:=NIL;
          QUOTECHAR:=CH;
          REPEAT
            REPEAT
              IF CHCNT>LINELENGTH THEN ERROR(202);
              NEXTCH; LGTH:=LGTH+1;
              IF LGTH>STRGLGTH THEN
                BEGIN NEW(LVP1);
                  IF LVP<>NIL THEN LVP^.SPTR:=LVP1
                  ELSE VAL.VALP:=LVP1;
                  LVP:=LVP1;
                  LVP^.SVAL:=STRING; LVP^.SLGTH:=STRGLGTH;
                  LVP^.SPTR:=NIL;
                  LGTH:=1
                END;
              STRING[LGTH]:=ICH
            UNTIL CH=QUOTECHAR;
            NEXTCH
          UNTIL CH<>QUOTECHAR;
          LGTH:=LGTH-1;   (* NOW LGTH=NR CHARS IN STRING *)
          IF (LGTH=1) AND (LVP=NIL) THEN VAL.IVAL:=STRING[1]
          ELSE
            IF LGTH<>0 THEN
              BEGIN NEW(LVP1);
                IF LVP<>NIL THEN LVP^.SPTR:=LVP1 ELSE VAL.VALP:=LVP1;
                LVP1^.SVAL:=STRING; LVP1^.SLGTH:=LGTH;
                LVP1^.SPTR:=NIL;
                LGTH:=STRINGSIZE(VAL.VALP)
              END;
        END;
  ':': (* BECOMES/COLON *)
        BEGIN OP:=NOOP; NEXTCH;
          IF CH='=' THEN
            BEGIN SY:=BECOMES; NEXTCH END
          ELSE SY:=COLON
        END;
  '.': (* DOTDOT/PERIOD *)
        BEGIN OP:=NOOP; NEXTCH;
          IF CH='.' THEN
            BEGIN SY:=DOTDOT; NEXTCH END
          ELSE SY:=PERIOD
        END;
  '<': (* LESS/NOT EQUAL *)
        BEGIN NEXTCH; SY:=RELOP;
          IF CH='=' THEN
            BEGIN OP:=LEOP; NEXTCH END
          ELSE
            IF CH='>' THEN
              BEGIN OP:=NEOP; NEXTCH END
            ELSE OP:=LTOP
        END;
  '>': (* GREATER/GREATER EQUAL *)
        BEGIN NEXTCH; SY:=RELOP;
          IF CH='=' THEN
            BEGIN OP:=GEOP; NEXTCH END
          ELSE OP:=GTOP
        END;
  '(': (* PAREN/COMMENT *)
        BEGIN NEXTCH;
          IF CH='*' THEN
            BEGIN NEXTCH;
              IF CH="$" THEN
                BEGIN NEXTCH;
                IF CH="I" THEN INCLUDEFILE
                END;
              REPEAT
                WHILE CH<>'*' DO NEXTCH;
                NEXTCH
              UNTIL CH=')';
              NEXTCH; COMNT:=FALSE
            END
          ELSE BEGIN SY:=LPARENT; OP:=NOOP END
        END;
   OTHERWISE (* NONE OF ABOVE *)
        SY:=SSY[CH]; OP:=SOP[CH]; NEXTCH;
          IF SY=OTHERSY THEN ERROR(399)
      END (* CASE *)
  UNTIL COMNT
END (* INSYMBOL *);

PROCEDURE ENTERID(FCP: CTP);
(* ENTER ID POINTED AT BY FCP INTO THE NAME-TABLE,
   WHICH ON EACH DECLARATION LEVEL IS ORGANIZED AS
   AN UNBALANCED BINARY TREE *)
VAR NAM: ALPHA; LCP,LCP1: CTP; LLEFT: BOOLEAN;
BEGIN NAM:=FCP^.NAME;
  LCP:=DISPLAY[TOP];
  IF LCP=NIL THEN
    DISPLAY[TOP]:=FCP
  ELSE
    BEGIN
      REPEAT LCP1:=LCP;
        IF LCP^.NAME=NAM THEN  (* NAME CONFLICT, FOLLOW RIGHT LINK *)
          BEGIN ERROR(101); LCP:=LCP^.RLINK; LLEFT:=FALSE END
        ELSE
          IF LCP^.NAME<NAM THEN
            BEGIN LCP:=LCP^.RLINK; LLEFT:=FALSE END
          ELSE BEGIN LCP:=LCP^.LLINK; LLEFT:=TRUE END
      UNTIL LCP=NIL;
      IF LLEFT THEN LCP1^.LLINK:=FCP ELSE LCP1^.RLINK:=FCP
    END;
  FCP^.LLINK:=NIL; FCP^.RLINK:=NIL
END (* ENTERID *);

PROCEDURE SEARCHSECTION(FCP: CTP; VAR FCP1: CTP);
(* TO FIND RECORD FIELDS AND FORWARD DECLARED PROCEDURE ID'S
   --> PROCEDURE PROCEDUREDECLARATION
   --> PROCEDURE SELECTOR *)
BEGIN
  FCP1:=NIL;
  WHILE (FCP<>NIL) AND (FCP1=NIL) DO
    IF FCP^.NAME<>ID THEN
      IF FCP^.NAME<ID THEN FCP:=FCP^.RLINK
      ELSE FCP:=FCP^.LLINK
    ELSE FCP1:=FCP
END (* SEARCHSECTION *);

PROCEDURE SEARCHID(FIDCLS: SETOFIDS; VAR FCP: CTP);
VAR LCP: CTP;
BEGIN
  DISX:=TOP+1; FCP:=NIL;
  WHILE (DISX>0) AND (FCP=NIL) DO
    BEGIN DISX:=DISX-1;
      LCP:=DISPLAY[DISX];
      WHILE (LCP<>NIL) AND (FCP=NIL) DO
        IF LCP^.NAME=ID THEN
          IF LCP^.KLASS IN FIDCLS THEN FCP:=LCP
          ELSE
            BEGIN IF PRTERR THEN ERROR(103);
              LCP:=LCP^.RLINK
            END
        ELSE
          IF LCP^.NAME<ID THEN
            LCP:=LCP^.RLINK
          ELSE LCP:=LCP^.LLINK
    END;
(* SEARCH NOT SUCCESSFUL; SUPPRESS ERROR MESSAGE IN CASE
   OF FORWARD REFERENCED TYPE ID IN POINTER TYPE DEFINITION
   --> PROCEDURE SIMPLETYPE *)
  IF PRTERR AND (FCP=NIL) THEN
    BEGIN ERROR(104);
      (* TO AVOID RETURNING NIL, REFERENCE AN ENTRY FOR
         UNDECLARED ID OF APPROPRIATE CLASS
         --> PROCEDURE ENTERUNDECL *)
      IF TYPES IN FIDCLS THEN FCP:=UTYPPTR
      ELSE
        IF VARS IN FIDCLS THEN FCP:=UVARPTR
        ELSE
          IF FIELD IN FIDCLS THEN FCP:=UFLDPTR
          ELSE
            IF KONST IN FIDCLS THEN FCP:=UCSTPTR
            ELSE
              IF PROC IN FIDCLS THEN FCP:=UPRCPTR
              ELSE FCP:=UFCTPTR;
    END;
END (* SEARCHID *);

PROCEDURE GETBOUNDS(FSP: STP; VAR FMIN,FMAX: INTEGER);
(* GET INTERNAL BOUNDS OF SUBRANGE OR SCALAR TYPE *)
(* ASSUME (FSP<>NIL) AND (FSP^.FORM<=SUBRANGE) AND (FSP<>INTPTR)
   AND NOT COMPTYPES(REALPTR,FSP) *)
BEGIN
  IF FSP^.FORM=SUBRANGE THEN
    BEGIN FMIN:=FSP^.MIN.IVAL; FMAX:=FSP^.MAX.IVAL END
  ELSE
    BEGIN FMIN:=0;
      IF FSP=CHARPTR THEN FMAX:=127
      ELSE
        IF FSP=INTPTR THEN FMAX:=MAXINT
        ELSE FMAX:=FSP^.FSTFLD^.VALUES.IVAL
    END
END (* GETBOUNDS *);

PROCEDURE WRITEOUT;
VAR I: INTEGER;
  HEADER: RECORD VAL: CHAR; LEN: CHAR END;
BEGIN (* WRITEOUT *)
  IF ICN<>0 THEN
    BEGIN HEADER.VAL:=CHR(1); HEADER.LEN:=CHR(ICN);
    PUTS(LGO,HEADER.VAL,2);
    PUTS(LGO,CODEBUF[0],ICN);
    END;
  IC:=IC+ICN; ICN:=0
END (* WRITEOUT *);

PROCEDURE BLOCK(FSYS: SETOFSYS; FSY: SYMBOL; FPROCP: CTP);
TYPE OPRANGE=0..255;
VAR LSY: SYMBOL; TEST: BOOLEAN;

  PROCEDURE BYTEGEN(BYTE: INTEGER);
  BEGIN
    IF ICN=127 THEN WRITEOUT;
    CODEBUF[ICN]:=CHR(BYTE);
    ICN:=ICN+1
  END (* BYTEGEN *);

  PROCEDURE OPGEN(PC: PCODES);
  BEGIN BYTEGEN(ORD(PC)+SOPPC) END;

  PROCEDURE ADDRGEN(ADDR: INTEGER);
  VAR D:DATAREC;
  BEGIN
    D.I:=ADDR;
    BYTEGEN(ORD(D.A[1]));
    BYTEGEN(ORD(D.A[2]))
  END (* ADDRGEN *);

  PROCEDURE GENUJPENT(FOP: PCODES; FP2: INTEGER);
  BEGIN
      OPGEN(FOP); ADDRGEN(FP2)
  END (* GENUJPENT *);

  PROCEDURE PLANTADDR(LOC,VAL: INTEGER);
  VAR HEADER: RECORD HDR: CHAR;
                LOC: INTEGER; VAL:INTEGER
                END;
  BEGIN
    IF VAL<>0 THEN
      IF (LOC>=IC)AND(LOC-IC<ICN) THEN
        BEGIN LOC:=LOC-IC; CODEBUF[LOC]:=CHR(VAL DIV 256);
          CODEBUF[LOC+1]:=CHR(VAL MOD 256)
        END
      ELSE
        BEGIN HEADER.HDR:=CHR(2); 
          HEADER.LOC:=LOC; HEADER.VAL:=VAL;
          IF LOC+1=IC THEN WRITEOUT;
          PUTS(LGO,HEADER.HDR,5)
        END
  END (* PLANTADDR *);

  PROCEDURE SKIP(FSYS: SETOFSYS);
  (* SKIP INPUT STRING UNTIL RELEVANT SYMBOL FOUND *)
  BEGIN WHILE NOT(SY IN FSYS) DO INSYMBOL
  END (* SKIP *);

  PROCEDURE TEST1(FSYS: SETOFSYS; N: INTEGER);
  BEGIN
    IF NOT(SY IN FSYS) THEN
      BEGIN ERROR(N); SKIP(FSYS) END
  END (* TEST1 *);

  PROCEDURE TEST2(FSYS: SETOFSYS; N: INTEGER; S2: SETOFSYS);
  BEGIN
    IF NOT(SY IN FSYS) THEN
      BEGIN ERROR(N); SKIP(FSYS+S2) END
  END (* TEST2 *);

  PROCEDURE INTEST(SYM: SYMBOL; N: INTEGER);
  BEGIN
    IF SY=SYM THEN INSYMBOL ELSE ERROR(N)
  END (* INTEST *);

